local pFrame, pFrameTitle, pFrameTitleText
local HealBot_Plugin_luVars={}
local HealBot_Plugin_Config={}
local HealBot_Plugin={}
local LSM = HealBot_Libs_LSM()
HealBot_Plugin_luVars["frameInit"]=false
local pId="TimeToLive"
local pBars={}
local TimeNow=GetTime()

local hbBarTextLen=10
local hbFontVal={ ["Accidental Presidency"]=3,
                  ["Alba Super"]=1.4,
                  ["Anime Ace"]=1,
                  ["Ariel Narrow"]=3,
                  ["Blazed"]=1.1,
                  ["Designer Block"]=1.7,
                  ["DestructoBeam BB"]=1.4,
                  ["Diogenes"]=2.1,
                  ["Disko"]=1.9,
                  ["DreamSpeak"]=3,
                  ["Drummon"]=1.5,
                  ["Dustismo"]=1.9,
                  ["Electrofied"]=1.1,
                  ["Emblem"]=1.7,
                  ["Frakturika Spamless"]=2.4,
                  ["Friz Quadrata TT"]=1.6,
                  ["Impact"]=2,
                  ["Liberation Sans"]=1.6,
                  ["Liberation Serif"]=1.8,
                  ["Morpheus"]=1.9,
                  ["Mystic Orbs"]=1.2,
                  ["Pokemon Solid"]=1.9,
                  ["Rock Show Whiplash"]=2.4,
                  ["SF Diego Sans"]=1.5,
                  ["SF Laundromatic"]=3,
                  ["Skurri"]=2.2,
                  ["Solange"]=1.4,
                  ["Star Cine"]=1,
                  ["Trashco"]=1.6,
                  ["Waltograph UI"]=1,
                  ["X360"]=1.4,
                  ["Zekton"]=1.6,
 }
local vSetTextLenWidthAdj,vSetTextLenFontAdj=1.1,0
local function HealBot_Plugin_SetTextLen()
    if HealBot_Plugin_Config.playertxtchars[HealBot_Plugin.Profile]==0 then
        vSetTextLenFontAdj=hbFontVal[HealBot_Plugin_Config.font[HealBot_Plugin.Profile]] or 2
        hbBarTextLen = floor((vSetTextLenFontAdj*2)+((HealBot_Plugin_Config.frameWidth[HealBot_Plugin.Profile]*vSetTextLenWidthAdj)
                                /(HealBot_Plugin_Config.fontsize[HealBot_Plugin.Profile])))-12
		if hbBarTextLen<1 then hbBarTextLen=1 end
    else
        hbBarTextLen = HealBot_Plugin_Config.playertxtchars[HealBot_Plugin.Profile]
    end
end

local function HealBot_Plugin_Name(name)
	if string.len(name)>hbBarTextLen then
		name=string.sub(name,1,hbBarTextLen).."."
	end
	return name
end

local function HealBot_Plugin_SetPoint(new)
	local fTop=HealBot_Plugin_Config.frameY[HealBot_Plugin.Profile]
	local fLeft=HealBot_Plugin_Config.frameX[HealBot_Plugin.Profile]
	if new then
		fTop=pFrame:GetTop() or HealBot_Plugin_Config.frameY[HealBot_Plugin.Profile]
		fLeft=pFrame:GetLeft() or HealBot_Plugin_Config.frameX[HealBot_Plugin.Profile]
	end
	if fTop>GetScreenHeight() then fTop=GetScreenHeight(); end
	if fTop<pFrame:GetHeight() then fTop=pFrame:GetHeight(); end
	if fLeft>GetScreenWidth()-pFrame:GetWidth() then fLeft=GetScreenWidth()-pFrame:GetWidth() end
	if fLeft<0 then fLeft=0 end
	HealBot_Plugin_Config.frameY[HealBot_Plugin.Profile] = ceil(fTop)
	HealBot_Plugin_Config.frameX[HealBot_Plugin.Profile] = ceil(fLeft)
	pFrame:ClearAllPoints()
	pFrame:SetPoint("TOPLEFT","UIParent","BOTTOMLEFT",
	                     HealBot_Plugin_Config.frameX[HealBot_Plugin.Profile],
						 HealBot_Plugin_Config.frameY[HealBot_Plugin.Profile]);
end

local function HealBot_Plugin_UpdateTitle()
	pFrameTitleText:SetFont(LSM:Fetch('font',HealBot_Plugin_Config.font[HealBot_Plugin.Profile]),
                                             HealBot_Plugin_Config.fontsize[HealBot_Plugin.Profile])
	pFrameTitleText:SetText(HealBot_Plugin_Config.titletext[HealBot_Plugin.Profile])
end

local function HealBot_Plugin_SetTitle()
    pFrameTitle=CreateFrame("StatusBar", "HealBot_"..pId.."_FrameTitle", pFrame)
	pFrameTitle:SetPoint("TOPLEFT",pFrame, 2, -2)
    pFrameTitle:SetHeight(19)
    pFrameTitle:SetWidth(HealBot_Plugin_Config.frameWidth[HealBot_Plugin.Profile]-4)
	pFrameTitle:SetStatusBarTexture("Interface\\AddOns\\HealBot\\Images\\bar8.tga")
	pFrameTitleText=pFrameTitle:CreateFontString("HealBot_"..pId.."_FrameTitleText", "ARTWORK", "GameFontNormal")
	pFrameTitleText:SetPoint("TOP", pFrameTitle, "TOP", 0, -4)
	HealBot_Plugin_UpdateTitle()
	HealBot_Plugin_TimeToLive_SetTitleCol()
end

local function HealBot_Plugin_OnMouseDown(self, button)
    if not HealBot_Plugin_Config.frameLocked[HealBot_Plugin.Profile] then
		if button=="LeftButton" and not pFrame.isMoving then
			pFrame:StartMoving();
			pFrame.isMoving = true;
		end
    end
end

local function HealBot_Plugin_OnMouseUp(self, button)
    if button=="LeftButton" and pFrame.isMoving then
		pFrame:StopMovingOrSizing();
		pFrame.isMoving = false;
		local fTop=pFrame:GetTop()
		local fLeft=pFrame:GetLeft()
		if (fTop>GetScreenHeight()) or 
		   (fTop<pFrame:GetHeight()) or 
		   (fLeft>GetScreenWidth()-pFrame:GetWidth()) or 
		   (fLeft<0) then 
			HealBot_Plugin_SetPoint(true)
		else
			HealBot_Plugin_Config.frameY[HealBot_Plugin.Profile] = ceil(fTop)
			HealBot_Plugin_Config.frameX[HealBot_Plugin.Profile] = ceil(fLeft)
		end
    elseif button=="RightButton" and not HealBot_Data["UILOCK"] and HealBot_Globals.RightButtonOptions then
        HealBot_Action_OptionsButton_OnClick();
    end
end

local function HealBot_Plugin_UpdateUsedMedia(mediatype, key)
    if mediatype == "statusbar" then
		for f=1,40 do
			if pBars[f] then
				pBars[f]:SetStatusBarTexture(LSM:Fetch('statusbar',HealBot_Plugin_Config.texture[HealBot_Plugin.Profile]))
			else
				break
			end
		end
    elseif mediatype == "font" then
		for f=1,40 do
			if pBars[f] then
				pBars[f].TextL:SetFont(LSM:Fetch('font',HealBot_Plugin_Config.font[HealBot_Plugin.Profile]),
											HealBot_Plugin_Config.fontsize[HealBot_Plugin.Profile],
											HealBot_Font_Outline[HealBot_Plugin_Config.txtoutline[HealBot_Plugin.Profile]])
				pBars[f].TextR:SetFont(LSM:Fetch('font',HealBot_Plugin_Config.font[HealBot_Plugin.Profile]),
											HealBot_Plugin_Config.fontsize[HealBot_Plugin.Profile],
											HealBot_Font_Outline[HealBot_Plugin_Config.txtoutline[HealBot_Plugin.Profile]])
			else
				break
			end
		end
    end
end

function HealBot_Plugin_TimeToLive_Init()
	if not HealBot_Plugin_luVars["pluginInit"] then
		table.foreach(HealBot_Plugin_TimeToLiveDefaults, function (key,val)
			if HealBot_Plugin_TimeToLive[key]==nil then
				HealBot_Plugin_TimeToLive[key] = val;
			end
		end);
		table.foreach(HealBot_Plugin_TimeToLive_ConfigDefaults, function (key,val)
			if HealBot_Plugin_TimeToLive_Config[key]==nil then
				HealBot_Plugin_TimeToLive_Config[key] = val;
			end
		end);
		HealBot_Plugin_Config=HealBot_Plugin_TimeToLive_Config
		HealBot_Plugin=HealBot_Plugin_TimeToLive
		if HealBot_Plugin.Profile~="Global" then 
			HealBot_Plugin.Profile=UnitName("player") 
			table.foreach(HealBot_Plugin_TimeToLive_ConfigDefaults, function (key,val)
				if HealBot_Plugin_Config[key][HealBot_Plugin.Profile]==nil then
					HealBot_Plugin_Config[key][HealBot_Plugin.Profile]=HealBot_Plugin_Config[key]["Global"];
				end
			end);
		end
		
		pFrame=CreateFrame("Frame", "HealBot_TimeToLive_Frame", UIParent, BackdropTemplateMixin and "BackdropTemplate")
		pFrame:SetBackdrop({
			bgFile = "Interface\\Addons\\HealBot\\Images\\WhiteLine",
			edgeFile = "Interface\\Addons\\HealBot\\Images\\border",
			tile = true,
			tileSize = 8,
			edgeSize = 8,
			insets = { left = 3, right = 3, top = 3, bottom = 3, },
		})
		pFrame:SetMovable(true)
		pFrame:EnableMouse(true)
		pFrame:SetScript("OnMouseDown", function(self, button) HealBot_Plugin_OnMouseDown(self, button) end)
		pFrame:SetScript("OnMouseUp", function(self, button) HealBot_Plugin_OnMouseUp(self, button) end)

		pFrame:SetWidth(HealBot_Plugin_Config.frameWidth[HealBot_Plugin.Profile])
		if HealBot_Plugin_Config.frameX[HealBot_Plugin.Profile]==-1 then
			HealBot_Plugin_Config.frameX[HealBot_Plugin.Profile]=10
		end
		if HealBot_Plugin_Config.frameY[HealBot_Plugin.Profile]==-1 then
			HealBot_Plugin_Config.frameY[HealBot_Plugin.Profile]=HealBot_Comm_round(GetScreenHeight()/2,0)
		end 
        LSM.RegisterCallback(HEALBOT_HEALBOT..pId, "LibSharedMedia_SetGlobal", function(mediatype, key) HealBot_Plugin_UpdateUsedMedia(mediatype, key) end)
		HealBot_Plugin_SetTitle()
		HealBot_Plugin_luVars["pluginInit"]=true
	end
	HealBot_Plugin_TimeToLive_UpdateAll()
	if HealBot_Globals.PluginTimeToLive then HealBot_setOptions_Timer(3300) end
end

local units={}
local hbp_unitInfo={}
local hbp_damage={}
local hbp_unitStatus={}
local uIdx=0
local hbp_prevMaxBar=1
local hbp_curBar=0
local hbp_update=false
local hbp_lastUpdate=TimeNow

local function HealBot_Plugin_UpdateFrameHeight()
	local h=23+((HealBot_Plugin_Config.height[HealBot_Plugin.Profile]+HealBot_Plugin_Config.rowspace[HealBot_Plugin.Profile])*HealBot_Plugin_luVars["maxBars"])
	pFrame:SetHeight(h)
end

local scpR, scpG, scpB=1,1,1
local function HealBot_Plugin_StatusColourPct(resstart)
	scpR, scpG, scpB=0,0,0
	if resstart==0 then 
		scpR = 1
	elseif resstart>TimeNow-9.9 then
		scpG = 1
	else
		scpG = 0.5
		scpR = 0.1
		scpB = 0.1
	end
    return scpR, scpG, scpB
end

local stcR, stcG, stcB=1,1,1
local function HealBot_Plugin_SetTextCols(bar, r, g, b, resstart)
	if HealBot_Plugin_Config.txtcoltype[HealBot_Plugin.Profile]==1 then
		bar.TextL:SetTextColor(r, g, b, HealBot_Plugin_Config.bartxtA[HealBot_Plugin.Profile])
		bar.TextR:SetTextColor(r, g, b, HealBot_Plugin_Config.bartxtA[HealBot_Plugin.Profile])
	elseif HealBot_Plugin_Config.txtcoltype[HealBot_Plugin.Profile]==2 then
		stcR, stcG, stcB=HealBot_Plugin_StatusColourPct(resstart)
		bar.TextL:SetTextColor(stcR, stcG, stcB, HealBot_Plugin_Config.bartxtA[HealBot_Plugin.Profile])
		bar.TextR:SetTextColor(stcR, stcG, stcB, HealBot_Plugin_Config.bartxtA[HealBot_Plugin.Profile])
	else
		bar.TextL:SetTextColor(HealBot_Plugin_Config.bartxtR[HealBot_Plugin.Profile],
		                       HealBot_Plugin_Config.bartxtG[HealBot_Plugin.Profile],
							   HealBot_Plugin_Config.bartxtB[HealBot_Plugin.Profile],
							   HealBot_Plugin_Config.bartxtA[HealBot_Plugin.Profile])
		bar.TextR:SetTextColor(HealBot_Plugin_Config.bartxtR[HealBot_Plugin.Profile],
		                       HealBot_Plugin_Config.bartxtG[HealBot_Plugin.Profile],
							   HealBot_Plugin_Config.bartxtB[HealBot_Plugin.Profile],
							   HealBot_Plugin_Config.bartxtA[HealBot_Plugin.Profile])
	end
end

local sbcR, sbcG, sbcB=1,1,1
local function HealBot_Plugin_SetBarCols(bar, r, g, b, resstart)
    if HealBot_Plugin_Config.coltype[HealBot_Plugin.Profile]==1 then
        bar:SetStatusBarColor(r, g, b, HealBot_Plugin_Config.barA[HealBot_Plugin.Profile])
    elseif HealBot_Plugin_Config.coltype[HealBot_Plugin.Profile]==2 then
        sbcR, sbcG, sbcB=HealBot_Plugin_StatusColourPct(resstart)
        bar:SetStatusBarColor(sbcR, sbcG, sbcB, HealBot_Plugin_Config.barA[HealBot_Plugin.Profile])
    else
        bar:SetStatusBarColor(HealBot_Plugin_Config.barR[HealBot_Plugin.Profile],
                              HealBot_Plugin_Config.barG[HealBot_Plugin.Profile],
                              HealBot_Plugin_Config.barB[HealBot_Plugin.Profile],
                              HealBot_Plugin_Config.barA[HealBot_Plugin.Profile])
    end
end

HealBot_Plugin_luVars["maxBars"]=0
local function HealBot_Plugin_TimeToLive_Update()
	hbp_curBar=0
	hbp_update=false
	table.sort(units,function (a,b)
		if hbp_unitStatus[a]<hbp_unitStatus[b] then 
			return true 
		else
			return false
		end
	end)
	for i,guid in ipairs(units) do
		hbp_curBar=hbp_curBar+1
		if hbp_curBar<=HealBot_Plugin_luVars["maxBars"] then
			if pBars[hbp_curBar].guid~=guid then
				pBars[hbp_curBar].guid=guid
				HealBot_Plugin_SetBarCols(pBars[hbp_curBar], 
										  hbp_unitInfo[guid]["r"],
										  hbp_unitInfo[guid]["g"],
										  hbp_unitInfo[guid]["b"],
										  hbp_unitInfo[guid]["resstart"])
				HealBot_Plugin_SetTextCols(pBars[hbp_curBar], 
										   hbp_unitInfo[guid]["r"],
										   hbp_unitInfo[guid]["g"],
										   hbp_unitInfo[guid]["b"],
										   hbp_unitInfo[guid]["resstart"])
				pBars[hbp_curBar].TextL:SetText(hbp_unitInfo[guid]["name"])
                if HealBot_Plugin_luVars["frameVisible"] then
                    pBars[hbp_curBar]:Show()
                end
			end
			if pBars[hbp_curBar].status~=hbp_unitStatus[guid] then
				if HealBot_Plugin_Config.coltype[HealBot_Plugin.Profile]==2 then
					HealBot_Plugin_SetBarCols(pBars[hbp_curBar], 
											  hbp_unitInfo[guid]["r"],
											  hbp_unitInfo[guid]["g"],
											  hbp_unitInfo[guid]["b"],
											  hbp_unitInfo[guid]["resstart"])
				end
				if HealBot_Plugin_Config.txtcoltype[HealBot_Plugin.Profile]==2 then
					HealBot_Plugin_SetTextCols(pBars[hbp_curBar], 
											   hbp_unitInfo[guid]["r"],
											   hbp_unitInfo[guid]["g"],
											   hbp_unitInfo[guid]["b"],
											   hbp_unitInfo[guid]["resstart"])
				end
				if hbp_unitInfo[guid]["resstart"]==0 then 
					pBars[hbp_curBar].TextR:SetText(HEALBOT_WORDS_REQUIRED)
				elseif hbp_unitInfo[guid]["resstart"]>TimeNow-9.9 then
					pBars[hbp_curBar].TextR:SetText(HEALBOT_EMOTE_INCOMING)
				else
					pBars[hbp_curBar].TextR:SetText(HEALBOT_WORDS_PENDING)
				end
				pBars[hbp_curBar].status=hbp_unitStatus[guid]
			end
			if hbp_unitInfo[guid]["lastupdate"]<TimeNow-15 then
				if not HealBot_Action_IsUnitDead(guid) then
					HealBot_Plugin_TTLRemoveUnit(guid)
				else
					hbp_unitInfo[guid]["lastupdate"]=TimeNow
				end
			end
		else
			hbp_curBar=hbp_curBar-1
			break
		end
	end
	if hbp_curBar<hbp_prevMaxBar then
		for f=hbp_curBar+1,hbp_prevMaxBar do
			if pBars[f].guid~="unused" then
				pBars[f].guid="unused"
				pBars[f].status=-1
				pBars[f]:Hide()
			end
		end
		if hbp_curBar==0 then
			pFrame:SetScript("OnUpdate", nil)
			HealBot_Plugin_luVars["OnUpdate"]=false
			if HealBot_Plugin_Config.OnlyShowOnDemand[HealBot_Plugin.Profile] then
				HealBot_Plugin_TimeToLive_HidePanel()
			end
            if HealBot_Plugin_luVars["cleardown"] then
                HealBot_Plugin_TimeToLive_Cleardown()
            end
		end
	end
	hbp_prevMaxBar=hbp_curBar
	hbp_lastUpdate=TimeNow
end

local function HealBot_Plugin_OnUpdate(self)
	TimeNow=GetTime()
	if (hbp_update and hbp_lastUpdate<TimeNow-0.2) or (hbp_curBar>0 and hbp_lastUpdate<TimeNow-1) then
		HealBot_Plugin_TimeToLive_Update()
	end
end

local function HealBot_Plugin_RemoveUnit(guid)
	if hbp_unitInfo[guid].active then
		uIdx=0
		for j=1, #units do
			if guid==units[j] then
				uIdx=j
				break;
			end
		end
		if uIdx>0 then
			table.remove(units,uIdx)
		end
		hbp_unitInfo[guid].active=false
	end
	hbp_update=true
end

function HealBot_Plugin_TTLRemoveUnit(guid)
	HealBot_Plugin_RemoveUnit(guid)
	if hbp_unitInfo[guid] then
		hbp_unitInfo[guid]=nil
	end
end

local function HealBot_Plugin_InsertUnit(guid)
	if not hbp_unitInfo[guid].active then
		table.insert(units,guid)
		if not HealBot_Plugin_luVars["OnUpdate"] then
			HealBot_Plugin_luVars["OnUpdate"]=true
			pFrame:SetScript("OnUpdate", HealBot_Plugin_OnUpdate)
			if HealBot_Plugin_Config.OnlyShowOnDemand[HealBot_Plugin.Profile] then
				HealBot_Plugin_TimeToLive_ShowPanel()
			end
		end
	end
	hbp_unitInfo[guid].active=true
end

function HealBot_Plugin_TimeToLive_UnitUpdate(button, hasRes)
	if button.status.current==9 then
		TimeNow=GetTime()
		if not hbp_unitInfo[button.guid] or hbp_unitInfo[button.guid]["unit"]~=button.unit then
			if not hbp_unitInfo[button.guid] then 
				hbp_unitInfo[button.guid]={}
				hbp_unitInfo[button.guid].active=false
			end
			hbp_unitInfo[button.guid]["name"]=HealBot_Plugin_Name(HealBot_GetUnitName(button.unit, button.guid) or HEALBOT_WORDS_UNKNOWN)
			hbp_unitInfo[button.guid]["unit"]=button.unit
			hbp_unitInfo[button.guid]["resstart"]=0
			hbp_unitInfo[button.guid]["unit"]=button.unit
			hbp_unitInfo[button.guid]["r"]=button.text.r
			hbp_unitInfo[button.guid]["g"]=button.text.g
			hbp_unitInfo[button.guid]["b"]=button.text.b
			hbp_unitStatus[button.guid]="1"..TimeNow..hbp_unitInfo[button.guid]["name"]
		end
		if hasRes then 
			if hasRes==1 and hbp_unitInfo[button.guid]["resstart"]==0 then 
				hbp_unitInfo[button.guid]["resstart"]=TimeNow 
				hbp_unitStatus[button.guid]="2"..TimeNow..hbp_unitInfo[button.guid]["name"]
			elseif hasRes==2 then 
				hbp_unitStatus[button.guid]="3"..hbp_unitInfo[button.guid]["resstart"]..hbp_unitInfo[button.guid]["name"]
			end
		elseif hbp_unitInfo[button.guid]["resstart"]>0 then 
			hbp_unitInfo[button.guid]["resstart"]=0 
			hbp_unitStatus[button.guid]="1"..TimeNow..hbp_unitInfo[button.guid]["name"]
		end
		HealBot_Plugin_InsertUnit(button.guid)
		hbp_unitInfo[button.guid]["lastupdate"]=TimeNow
		hbp_update=true
	elseif hbp_unitInfo[button.guid] then
		HealBot_Plugin_RemoveUnit(button.guid)
	end
	hbp_update=true
end

function HealBot_Plugin_TimeToLive_TickUpdate(button)
	if hbp_unitInfo[button.guid] then
		if button.status.current<9 then
			HealBot_Plugin_RemoveUnit(button.guid)
		elseif hbp_unitInfo[button.guid]["resstart"]>0 then
			if hbp_unitInfo[button.guid]["resstart"]<TimeNow-120 then
				hbp_unitInfo[button.guid]["resstart"]=0 
				hbp_unitStatus[button.guid]="1"..TimeNow..hbp_unitInfo[button.guid]["name"]
			elseif hbp_unitInfo[button.guid]["resstart"]<TimeNow-10 and 
			       hbp_unitStatus[button.guid]~="3"..TimeNow..hbp_unitInfo[button.guid]["name"] then
				hbp_unitStatus[button.guid]="3"..TimeNow..hbp_unitInfo[button.guid]["name"]
			end
		end
	end
end

local function HealBot_Plugin_UpdateBarWidth(bar)
	bar:SetWidth(HealBot_Plugin_Config.frameWidth[HealBot_Plugin.Profile]-4)
end

local function HealBot_Plugin_UpdateBarSetPoint(bar)
	if bar.id==1 then
		bar:SetPoint("TOP", pFrameTitle, "BOTTOM", 0, 0-HealBot_Plugin_Config.rowspace[HealBot_Plugin.Profile])
	else
		bar:SetPoint("TOP", pBars[bar.id-1], "BOTTOM", 0, 0-HealBot_Plugin_Config.rowspace[HealBot_Plugin.Profile])
	end
end

local function HealBot_Plugin_UpdateBarHeight(bar)
	bar:SetHeight(HealBot_Plugin_Config.height[HealBot_Plugin.Profile])
end

local function HealBot_Plugin_UpdateBarText(bar)
	bar.TextL:SetFont(LSM:Fetch('font',HealBot_Plugin_Config.font[HealBot_Plugin.Profile]),
                                HealBot_Plugin_Config.fontsize[HealBot_Plugin.Profile],
                                HealBot_Font_Outline[HealBot_Plugin_Config.txtoutline[HealBot_Plugin.Profile]])
	bar.TextR:SetFont(LSM:Fetch('font',HealBot_Plugin_Config.font[HealBot_Plugin.Profile]),
                                HealBot_Plugin_Config.fontsize[HealBot_Plugin.Profile],
                                HealBot_Font_Outline[HealBot_Plugin_Config.txtoutline[HealBot_Plugin.Profile]])
end

local function HealBot_Plugin_UpdateBarTexture(bar)
	bar:SetStatusBarTexture(LSM:Fetch('statusbar',HealBot_Plugin_Config.texture[HealBot_Plugin.Profile]))
end

function HealBot_Plugin_TimeToLive_UpdateAll()
	if HealBot_Plugin_luVars["testMode"] then
		HealBot_Plugin_TimeToLive_TestMode(false)
		HealBot_Plugin_luVars["testModeOn"]=true
	end	
	for f=1,HealBot_Plugin_Config.maxBars[HealBot_Plugin.Profile] do
		if not pBars[f] then
			pBars[f]=CreateFrame("StatusBar", "ttlpBar_"..pId..f, pFrame) 
			pBars[f].id=f
			pBars[f].guid="nil"
			pBars[f].status=-1
			pBars[f]:SetMinMaxValues(0,100)
			pBars[f]:SetValue(100)
			pBars[f]:Hide()
			pBars[f].TextL=pBars[f]:CreateFontString()
			pBars[f].TextL:SetPoint("LEFT",0,-1)
			pBars[f].TextR=pBars[f]:CreateFontString()
			pBars[f].TextR:SetPoint("RIGHT",0,-1)
			HealBot_Plugin_UpdateBarTexture(pBars[f])
			HealBot_Plugin_UpdateBarText(pBars[f])
			HealBot_Plugin_UpdateBarHeight(pBars[f])
			HealBot_Plugin_UpdateBarWidth(pBars[f])
		end
		HealBot_Plugin_UpdateBarSetPoint(pBars[f])
	end
	HealBot_Plugin_luVars["maxBars"]=HealBot_Plugin_Config.maxBars[HealBot_Plugin.Profile]
	HealBot_Plugin_SetTextLen()
	HealBot_Plugin_SetPoint()
	HealBot_Plugin_UpdateTitle()
	HealBot_Plugin_UpdateFrameHeight()
	HealBot_Plugin_TimeToLive_Update()
	if HealBot_Plugin_luVars["testModeOn"] then
		HealBot_Plugin_TimeToLive_TestMode(true)
		HealBot_Plugin_luVars["testModeOn"]=false
	end	
end

function HealBot_Plugin_TimeToLive_UpdateTitle()
	HealBot_Plugin_UpdateTitle()
end

function HealBot_Plugin_TimeToLive_ShowPanel()
    if HealBot_Plugin_Config.OnlyShowOutOfCombat[HealBot_Plugin.Profile] and InCombatLockdown() then 
        HealBot_setOptions_Timer(3300)
    else
        HealBot_Plugin_TimeToLive_SetFrameCols()
        HealBot_Plugin_TimeToLive_SetTitleCol()
        pFrame:EnableMouse(true)
        HealBot_Plugin_luVars["frameVisible"]=true
		for f=1,hbp_curBar do
			if pBars[f].guid~="unused" then
				pBars[f]:Show()
			end
		end
    end
end

function HealBot_Plugin_TimeToLive_HidePanel()
    if not pFrame.isMoving then
        pFrame:SetBackdropColor(0,0,0,0)
        pFrame:SetBackdropBorderColor(0,0,0,0)
        pFrameTitle:SetStatusBarColor(0,0,0,0)
        pFrameTitleText:SetTextColor(0,0,0,0)
        pFrame:EnableMouse(false)
        HealBot_Plugin_luVars["frameVisible"]=false
    else
        HealBot_setOptions_Timer(3300)
    end
end

function HealBot_Plugin_TimeToLive_TogglePanel()
	if HealBot_Plugin_luVars["testMode"] then
		HealBot_Plugin_TimeToLive_ShowPanel()
	elseif HealBot_Plugin_Config.OnlyShowOnDemand[HealBot_Plugin.Profile] then
		if hbp_curBar==0 then
			HealBot_Plugin_TimeToLive_HidePanel()
		else
			HealBot_Plugin_TimeToLive_ShowPanel()
		end	
	else
		HealBot_Plugin_TimeToLive_ShowPanel()
	end
end

function HealBot_Plugin_TimeToLive_Shutdown()
	HealBot_Plugin_TimeToLive_Cleardown()
	HealBot_Plugin_TimeToLive_TestMode(false)
	HealBot_Plugin_Frame_TimeToLive_TestOff()
	HealBot_Plugin_TimeToLive_HidePanel()
end

function HealBot_Plugin_TimeToLive_Cleardown()
    if hbp_curBar==0 then
        for x,_ in pairs(units) do
            units[x]=nil;
        end
        for guid,_ in pairs(hbp_unitInfo) do
            if not HealBot_Panel_RaidUnitGUID(guid) then
                hbp_unitInfo[guid]=nil
                hbp_unitStatus[guid]=nil
            end
        end
    else
        HealBot_Plugin_luVars["cleardown"]=true
    end
end

function HealBot_Plugin_TimeToLive_UpdateBarRowSpacer()
	for f=1,40 do
		if pBars[f] then
			HealBot_Plugin_UpdateBarSetPoint(pBars[f])
		else
			break
		end
	end
	HealBot_Plugin_UpdateFrameHeight()
end

function HealBot_Plugin_TimeToLive_UpdateHeight()
	for f=1,40 do
		if pBars[f] then
			HealBot_Plugin_UpdateBarHeight(pBars[f])
		else
			break
		end
	end
	HealBot_Plugin_UpdateFrameHeight()
end

function HealBot_Plugin_TimeToLive_UpdateText()
	for f=1,40 do
		if pBars[f] then
			HealBot_Plugin_UpdateBarText(pBars[f])
		else
			break
		end
	end
end

function HealBot_Plugin_TimeToLive_UpdateTexture()
	for f=1,40 do
		if pBars[f] then
			HealBot_Plugin_UpdateBarTexture(pBars[f])
		else
			break
		end
	end
end

function HealBot_Plugin_TimeToLive_FrameWidth()
	pFrame:SetWidth(HealBot_Plugin_Config.frameWidth[HealBot_Plugin.Profile])
	pFrameTitle:SetWidth(HealBot_Plugin_Config.frameWidth[HealBot_Plugin.Profile]-4)
	for f=1,40 do
		if pBars[f] then
			HealBot_Plugin_UpdateBarWidth(pBars[f])
		else
			break
		end
	end
	HealBot_Plugin_SetTextLen()
end

function HealBot_Plugin_TimeToLive_SetFrameCols()
	pFrame:SetBackdropColor(HealBot_Plugin_Config.frameR[HealBot_Plugin.Profile],
	                             HealBot_Plugin_Config.frameG[HealBot_Plugin.Profile],
								 HealBot_Plugin_Config.frameB[HealBot_Plugin.Profile],
								 HealBot_Plugin_Config.frameA[HealBot_Plugin.Profile])
	pFrame:SetBackdropBorderColor(HealBot_Plugin_Config.borderR[HealBot_Plugin.Profile],
	                                   HealBot_Plugin_Config.borderG[HealBot_Plugin.Profile],
								       HealBot_Plugin_Config.borderB[HealBot_Plugin.Profile],
								       HealBot_Plugin_Config.borderA[HealBot_Plugin.Profile])
end

function HealBot_Plugin_TimeToLive_SetTitleCol()
	pFrameTitle:SetStatusBarColor(HealBot_Plugin_Config.titlebackR[HealBot_Plugin.Profile],
	                              HealBot_Plugin_Config.titlebackG[HealBot_Plugin.Profile],
								  HealBot_Plugin_Config.titlebackB[HealBot_Plugin.Profile],
								  HealBot_Plugin_Config.titlebackA[HealBot_Plugin.Profile])
	pFrameTitleText:SetTextColor(HealBot_Plugin_Config.titletextR[HealBot_Plugin.Profile], 
	                             HealBot_Plugin_Config.titletextG[HealBot_Plugin.Profile], 
								 HealBot_Plugin_Config.titletextB[HealBot_Plugin.Profile], 
								 HealBot_Plugin_Config.titletextA[HealBot_Plugin.Profile])
end

local hbp_testbars={}
local function HealBot_Plugin_TimeToLive_TestModeSetBar(i)
	local n=TimeNow
	if i<(HealBot_Plugin_luVars["maxBars"]/3) then
		n=0
		pBars[i].TextR:SetText(HEALBOT_WORDS_REQUIRED)
	elseif i>(HealBot_Plugin_luVars["maxBars"]*0.66) then
		n=20
		pBars[i].TextR:SetText(HEALBOT_WORDS_PENDING)
	else
		pBars[i].TextR:SetText(HEALBOT_EMOTE_INCOMING)
	end
	HealBot_Plugin_SetBarCols(pBars[i],hbp_testbars[i].r,hbp_testbars[i].g,hbp_testbars[i].b,n)
	HealBot_Plugin_SetTextCols(pBars[i],hbp_testbars[i].r,hbp_testbars[i].g,hbp_testbars[i].b,n)
end

local function HealBot_Plugin_TimeToLive_TestModeBar(i)
	local tcR,tcG,tcB=HealBot_Panel_RandomClassColour()
	if not hbp_testbars[i] then hbp_testbars[i]={} end
	hbp_testbars[i].r=tcR
	hbp_testbars[i].g=tcG
	hbp_testbars[i].b=tcB
	pBars[i].TextL:SetText(pBars[i].guid)
	pBars[i]:Show()
	HealBot_Plugin_TimeToLive_TestModeSetBar(i)
end

function HealBot_Plugin_TimeToLive_TestMode(enable)
	if enable then
		HealBot_Plugin_luVars["testMode"]=true
		hbp_curBar=0
		for i=1, HealBot_Plugin_luVars["maxBars"] do
			hbp_curBar=hbp_curBar+1
			if pBars[i].guid~="Player "..hbp_curBar then
				pBars[i].guid="Player "..hbp_curBar
				HealBot_Plugin_TimeToLive_TestModeBar(hbp_curBar)
			else
				HealBot_Plugin_TimeToLive_TestModeSetBar(hbp_curBar)
			end
			HealBot_Plugin_UpdateBarSetPoint(pBars[i])
		end
		for f=hbp_curBar+1,40 do
			if pBars[f] then 
				pBars[f]:Hide() 
				pBars[f].rel=-1
				pBars[f].guid="unused"
			end
		end
	else
		hbp_curBar=0
		for f=1,40 do
			if pBars[f] then 
				pBars[f]:Hide() 
				pBars[f].rel=-1
				pBars[f].guid="unused"
			end
		end
		HealBot_Plugin_luVars["testMode"]=false
		hbp_curBar=0
	end
	HealBot_Plugin_TimeToLive_TogglePanel()
	hbp_update=true
end
